/// <reference types="node" />
import * as https from 'https';
import { Agent as HttpsAgent } from 'https';
import * as http from 'http';
import { Agent as HttpAgent } from 'http';
import * as tunnel from 'tunnel';
import { ProxyOptions, HttpsProxyOptions } from 'tunnel';
import { Spread } from './types/utils';
export declare type IAgentOptions = tunnel.HttpOptions | tunnel.HttpOverHttpsOptions | tunnel.HttpsOverHttpOptions | tunnel.HttpsOverHttpsOptions;
export declare type IProxyOptions = ProxyOptions & {
    protocol: 'http:' | 'https:';
};
export declare type IProxyHttpsOptions = HttpsProxyOptions & {
    protocol: 'http:' | 'https:';
};
export declare type IOptions = Spread<Partial<https.AgentOptions> & IAgentOptions, {
    proxy: IProxyOptions | IProxyHttpsOptions | string;
    endServerProtocol?: 'http:' | 'https:';
}>;
export declare function getProxyHttpAgent(options: IOptions): http.Agent | https.Agent;
export { HttpsAgent, HttpAgent };
