"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpAgent = exports.HttpsAgent = exports.getProxyHttpAgent = void 0;
const https_1 = require("https");
Object.defineProperty(exports, "HttpsAgent", { enumerable: true, get: function () { return https_1.Agent; } });
const http_1 = require("http");
Object.defineProperty(exports, "HttpAgent", { enumerable: true, get: function () { return http_1.Agent; } });
const url = require("url");
const tunnel = require("tunnel");
function getProxyHttpAgent(options) {
    if (!options.proxy) {
        throw new Error('Proxy not provided');
    }
    if (typeof options.proxy === 'string') {
        const parsedUrl = url.parse(options.proxy);
        options.proxy = {
            ...parsedUrl,
            port: Number(parsedUrl.port)
        };
    }
    const proxy = options.proxy;
    if (!options.endServerProtocol) {
        options.endServerProtocol = 'https:';
    }
    let agent;
    if (proxy.protocol === 'http:') {
        if (options.endServerProtocol === 'http:') {
            agent = tunnel.httpOverHttp(options);
        }
        else {
            /**
             * https
             */
            agent = tunnel.httpsOverHttp(options);
        }
    }
    else {
        /**
         * https
         */
        if (options.endServerProtocol === 'http:') {
            agent = tunnel.httpOverHttps(options);
        }
        else {
            /**
             * https
             */
            agent = tunnel.httpsOverHttps(options);
        }
    }
    if (process.env.NODE_ENV === 'test') {
        // @ts-ignore
        agent.test_endServerProtocol = options.endServerProtocol;
    }
    return agent;
}
exports.getProxyHttpAgent = getProxyHttpAgent;
